﻿// --- FMvars_panelT.jsx ------ UTF-8 -------------------------------------------------------------
// to be included in FMvars.jsx

KLD_V.DialogueTransfer = function (){ // ==========================================================
/*            Dialogue for transfering variables
              Defnition of dialgoue elements and function of the lists and buttons
Called by     ImportExportVars, ButtonImpExport
Calling       BuildMsg, RbImport, RbExport, FillVarListObj, ButtonBrowse, ButtonGetVars, ButtonTransfer
Attention     To handle the "Change of document" and externalise the callback functions
              the windows ID must be set ouside this function; hence wPalV is global.
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  if (typeof  wPalV !== "undefined" && wPalV.active) { // is main palette open ?
    wPalV.close();
  }

  try {wDlgT  = new Window("dialog", undefined, undefined); }
  catch (e) {
    alert (KLD_V.BuildMsg (KLD_V.UItxt.wDlgT.@msg_01, e.message));
    return;
  }

  wDlgT.text    = KLD_V.UItxt.wDlgT.@title.toString() + KLD_V.APP_VERSION;
  wDlgT.margins = [5, 5, 5, 5];                   // left, top, right, bottom
	wDlgT.g1 = wDlgT.add('group',undefined);
	wDlgT.g1.alignChildren = ['left',' '];

	wDlgT.g1.p1 = wDlgT.g1.add('panel',undefined,KLD_V.UItxt.wDlgT.@g1p1.toString());
	wDlgT.g1.p1.alignChildren = ['left',' '];

	wDlgT.g1.p1.rbImport = wDlgT.g1.p1.add('radiobutton',undefined,KLD_V.UItxt.wDlgT.@g1p1rbImport.toString());
	wDlgT.g1.p1.rbImport.preferredSize.height = 20;
	wDlgT.g1.p1.rbImport.active = true;

	wDlgT.g1.p1.rbExport = wDlgT.g1.p1.add('radiobutton',undefined,KLD_V.UItxt.wDlgT.@g1p1rbExport.toString());
	wDlgT.g1.p1.rbExport.preferredSize.height = 20;

	wDlgT.g1.p2 = wDlgT.g1.add('panel',undefined,KLD_V.UItxt.wDlgT.@g1p2.toString());
	wDlgT.g1.p2.alignChildren = ['left',' '];

	wDlgT.g1.p2.sFileName = wDlgT.g1.p2.add('edittext',undefined,KLD_V.UItxt.wDlgT.@g1p2sFileName.toString());
	wDlgT.g1.p2.sFileName.preferredSize.width = 360;
	wDlgT.g1.p2.sFileName.preferredSize.height = 20;

	wDlgT.g1.p2.btnBrowse = wDlgT.g1.p2.add('button',undefined,KLD_V.UItxt.wDlgT.@g1p2btnBrowse.toString());
  wDlgT.g1.p2.btnBrowse.helpTip = KLD_V.UItxt.wDlgT.@g1p2btnBrowsehelpTip.toString();

	wDlgT.g2 = wDlgT.add('group',undefined);

	wDlgT.g2.p3 = wDlgT.g2.add('panel',undefined,KLD_V.UItxt.wDlgT.@g2p3.toString());
	wDlgT.g2.p3.alignChildren = ['left',' '];

	wDlgT.g2.p3.btnGetVars = wDlgT.g2.p3.add('button',undefined,KLD_V.UItxt.wDlgT.@g2p3btnGetVars.toString());
  wDlgT.g2.p3.btnGetVars.helpTip = KLD_V.UItxt.wDlgT.@g2p3btnGetVarshelpTip.toString();

	wDlgT.g2.p3.listSource = wDlgT.g2.p3.add('listbox',undefined,undefined);
	wDlgT.g2.p3.listSource.preferredSize.width = 200;
	wDlgT.g2.p3.listSource.preferredSize.height = 200;

	wDlgT.g2.p4 = wDlgT.g2.add('panel',undefined,KLD_V.UItxt.wDlgT.@g2p4.toString());
  wDlgT.g2.p4.s1 = wDlgT.g2.p4.add('statictext',undefined,KLD_V.UItxt.wDlgT.@g2p4s1.toString(),{multiline: true});
	wDlgT.g2.p4.s1.preferredSize = [240, 30];
  wDlgT.g2.p4.s1.alignment = ['left',' '];

	wDlgT.g2.p4.listTrans = wDlgT.g2.p4.add('listbox',undefined,undefined);
	wDlgT.g2.p4.listTrans.preferredSize.width = 240;
	wDlgT.g2.p4.listTrans.preferredSize.height = 190;

	wDlgT.g3 = wDlgT.add('group',undefined);

	wDlgT.g3.btnTransfer = wDlgT.g3.add('button',undefined,KLD_V.UItxt.wDlgT.@g3btnTransfer.toString());
  wDlgT.g3.btnTransfer.helpTip = KLD_V.UItxt.wDlgT.@g3btnTransferhelpTip.toString();

	wDlgT.g3.message = wDlgT.g3.add('statictext',undefined,"",{multiline: true}); // May get error message
	wDlgT.g3.message.preferredSize = [290,  30];    // -1 for automatic calcualtion not working here
	wDlgT.g3.message.graphics.foregroundColor = wDlgT.g3.message.graphics.newPen (wDlgT.g3.message.graphics.PenType.SOLID_COLOR, [1, 0, 0], 1);
	wDlgT.g3.message.justify = "left";

	wDlgT.g3.btnClose = wDlgT.g3.add('button',undefined,KLD_V.UItxt.wDlgT.@g3btnClose.toString());
  wDlgT.g3.btnClose.helpTip = KLD_V.UItxt.wDlgT.@g3btnClosehelpTip.toString();

// behaviour of radio buttons ---------------------------------------------------------------------
  wDlgT.g1.p1.rbImport.onClick                    = function () {
    KLD_V.RbImport ();
  };

  wDlgT.g1.p1.rbExport.onClick                    = function () {
    KLD_V.RbExport ();
  };

// --- behaviour of edit fields -------------------------------------------------------------------
  wDlgT.g1.p2.sFileName.onChange = function () {
//  alert ("sFileName has changed");
    oSrcFile = new File(wDlgT.g1.p2.sFileName.text);
    if (oSrcFile !== null) {
      KLD_V.sFileName = oSrcFile.fsName;
    }
  }

// --- behaviour of the lists ---------------------------------------------------------------------
// IMHO doubleClick is more user friendly as it indicates an action.
  wDlgT.g2.p3.listSource.onChange = function () { // --- single/double click
    var listIndex, sVarName, sVarValue;
    if (wDlgT.g2.p3.listSource.selection == null) {return;} // clicked into empty area
    listIndex = wDlgT.g2.p3.listSource.selection.valueOf(); // identical index in KLD_V.aoSourceVars
    oVar = KLD_V.aoSourceVars[listIndex];
    KLD_V.aoTransVars.push (oVar);                 // add item to the transfer array
    KLD_V.FillVarListObj (wDlgT.g2.p4.listTrans, KLD_V.aoTransVars);
  }

  wDlgT.g2.p4.listTrans.onDoubleClick = function () {
    var listIndex;
    listIndex = wDlgT.g2.p4.listTrans.selection.valueOf();
    wDlgT.g2.p4.listTrans.remove (listIndex);
    KLD_V.aoSourceVars.splice (listIndex, 1);
    KLD_V.aoTransVars.splice (listIndex, 1);       // array of var objects (name, value)
  }

// --- behaviour of the buttons -------------------------------------------------------------------
  wDlgT.g1.p2.btnBrowse.onClick                   = function () {
    KLD_V.ButtonBrowse ();                              // sets KLD_V.sFileName
  };

  wDlgT.g2.p3.btnGetVars.onClick                  = function () {
    KLD_V.ButtonGetVars (KLD_V.sFileName);
  }

  wDlgT.g3.btnTransfer.onClick                    = function () {
    KLD_V.ButtonTransfer (KLD_V.sFileName);
  }

  wDlgT.g3.btnClose.onClick                       = function () {
    wDlgT.close();
  };

// --- Final work in dialogue ---------------------------------------------------------------------
  wDlgT.g3.message.text = " ";
  wDlgT.show();
} //=== end of DialogueTransfer <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><

KLD_V.ButtonBrowse = function () { // =============================================================
/*            Browse for file name and open it
Arguments     sFileName: resulting file name
Called by     DialogueTransfer
*/
var oSrcFile, oUsrFile;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  wDlgT.g3.message.text = " ";
  oUsrFile = new File(KLD_V.oCurrentDoc.Name);     // start in same dir as current doc
  oSrcFile = oUsrFile.openDlg(KLD_V.UItxt.ButtonBrowse.@msg_01.toString(), KLD_V.UItxt.ButtonBrowse.@msg_02.toString());
  if (oSrcFile !== null) {
    wDlgT.g1.p2.sFileName.text = oSrcFile.fsName;
    KLD_V.sFileName = oSrcFile.fsName;
   }
} //--- end ButtonBrowse --------------------------------------------------------------------------

KLD_V.ButtonGetVars = function (sFilename) { // ===================================================
/*            get variables from depending file
Fills the     list of source variables
Arguments     sFilename: to be opened for import
Called by     DialogueTransfer
Calling       DocIsOpen, OpenSourceFile, GetVarNames, FillDlgList
Comment       Current doc is always open
*/
var bToBeClosed, oDoc, aNames = [];
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  if (KLD_V.bImport) {                            // --- importing from another file
    oDoc = KLD_V.DocIsOpen (sFilename);
    if (oDoc == null ) {                          // ext. file not yet open
      oDoc = KLD_V.OpenSourceFile (sFilename);
      bToBeClosed = true;
    } else {                                      // ext. file already open
      bToBeClosed = false;
    }
  } else {                                        // --- Exporting
    oDoc = KLD_V.oCurrentDoc;                     // exporting from current doc
    bToBeClosed = false;
  }
  if (oDoc == undefined) {
    wDlgT.g3.message.text = KLD_V.UItxt.ButtonGetVars.@msg_01.toString();
    return;
  }
  KLD_V.oSourceDoc = oDoc;
  KLD_V.GetVarNames (oDoc, aNames, KLD_V.aoSourceVars); // arrays updated in parallel
  KLD_V.FillDlgList (wDlgT.g2.p3.listSource, aNames);
  wDlgT.g2.p4.listTrans.removeAll();              // clear the target list
  KLD_V.aoTransVars.length = 0;                   // clear array
  if (bToBeClosed) {                              // this has not changed the dodument, hence no save
    oDoc.Close(Constants.FF_CLOSE_MODIFIED);      // close regrdless of state

  }
} //--- end ButtonGetVars -------------------------------------------------------------------------

KLD_V.ButtonHelpT = function () { // ==============================================================
/*
Calling       GetScriptPath, OpenPdfAtDestination
Comment       Currently no such UI element
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  KLD_V.sHelpFile = File (KLD_V.GetScriptPath () + "\\" + KLD_V.APP_NAME + ".pdf"); // abs URI notation
  if (KLD_V.sHelpFile.exists) {
    KLD_V.OpenPdfAtDestination (KLD_V.sHelpFile, "nameddest=M8.newlink.FMvars2");
  }
//KLD_V.OpenHelpFile ();
} //---  end ButtonHelpT --------------------------------------------------------------------------

KLD_V.ButtonTransfer = function (sFilename) { // ==================================================
/*            transfer the selected variables
Arguments     sFilename: target document for the variables to transfer
Called by     DialogueTransfer
Calling       DocIsOpen, OpenSourceFile, VarIsInCatalogue, BuildMsg
Attention     Already existing variables in the targt doc will be overwritten whithout notice.
Comment       Variables to be transerred are in KLD_V.aoTransVars.
              Equivalent list of names is in wDlgT.g2.p4.listTrans.
              Current doc is always open
*/
var j, bToBeClosed, nTrans, nChanged = 0, oDoc, oVarCatlg, sVarName, sVarValue;
  nTrans = KLD_V.aoTransVars.length;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  if (KLD_V.bImport) {                            // --- Importing into current doc
    oDoc = KLD_V.oCurrentDoc;
    bToBeClosed = false;
  } else {                                        // --- Exporting
    oDoc = KLD_V.DocIsOpen (sFilename);
    if (oDoc != null ) {                          // ext. file is already open
      bToBeClosed = false;
    } else {                                      // ext. file not yet open
      oDoc = KLD_V.OpenSourceFile (sFilename)
      bToBeClosed = true;
    }
  }
  if (oDoc == undefined) {
    wDlgT.g3.message.text = KLD_V.UItxt.ButtonTransfer.@msg_01.toString();
    return;
  }
  for (j = 0; j < nTrans; j++) {                  // create/update variables in target doc
    sVarName  = KLD_V.aoTransVars[j].Name;
    sVarValue = KLD_V.aoTransVars[j].Value;
    oVarCatlg = KLD_V.VarIsInCatalogue (oDoc, sVarName);
    if (oVarCatlg != null) {                      // does it exist already? All system vars do.
      nChanged += 1;
      oVarCatlg.Fmt = sVarValue;
    } else {                                      // create a new variable in catalogue
      oVarCatlg = oDoc.NewNamedVarFmt (sVarName);
      oVarCatlg.Fmt = sVarValue;
    }
  }

  wDlgT.g3.message.text =  KLD_V.BuildMsg (KLD_V.UItxt.ButtonTransfer.@msg_02, nTrans, nChanged);
  if (bToBeClosed) {                              // document has been modified, hence save
    oDoc.SimpleSave (oDoc.Name, false);           // not interactive
    oDoc.Close(Constants.FF_CLOSE_MODIFIED);      // close regardless of state
  }
} //--- end ButtonTransfer ------------------------------------------------------------------------

KLD_V.FillVarListObj = function (oList, aoVars) { // ==============================================
/*            Fill dialogue list from global object array
Arguments     oList:  dialogue list to be filled from the global array KLD_V.asUserVariables
              aoVars: global array with the variables (name. value)
Called by     DialogueTransfer
*/
var j, nVars;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  nVars = aoVars.length;
  oList.removeAll ();                             // clear the list
  for (j = 0; j < nVars; j++) {
    oList.add ("item", aoVars[j].Name);           // take only the name
  }
//$.bp(true);
} //--- end FillVarListObj ------------------------------------------------------------------------

KLD_V.RbImport = function () { // =================================================================
/*            Radiobutton Import
Called by     DialogueTransfer
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

	wDlgT.g1.p2.text = KLD_V.UItxt.RbImport.@msg_01.toString();
  KLD_V.bImport = true;
  KLD_V.oSourceDoc = undefined;                          // to be defined by open
  KLD_V.oTargetDoc = KLD_V.oCurrentDoc;
  wDlgT.g3.message.text = " ";
} //--- end RbImport ------------------------------------------------------------------------------

KLD_V.RbExport = function () { // =================================================================
/*            Radiobutton Export
Called by     DialogueTransfer
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

	wDlgT.g1.p2.text = KLD_V.UItxt.RbExport.@msg_01.toString();
  KLD_V.bImport = false;
  KLD_V.oSourceDoc = KLD_V.oCurrentDoc;
  KLD_V.oTargetDoc = undefined;                          // to be defined by open
  wDlgT.g3.message.text = " ";
} //--- end RbExport ------------------------------------------------------------------------------
