﻿// --- FMvars_panelV.jsx ------ UTF-8 -------------------------------------------------------------
// to be included in FMvars.jsx

KLD_V.PaletteVariables = function (){ // ==========================================================
/*            Palette for handling variables
              Defnition of dialgoue elements and function of the lists and buttons
Arguments     -
Attention     To handle the "Change of document" and externalise the callback functions
              the windows ID must be set ouside this function; hence wPalV is global.
Called by     HandleVariables
Calling       BuildMsg, RefreshGlobals, SetButtonInsert, CheckSystemBB, FillDlgList, RbSystemVars,
              RbUserVars, RbAnyVar, RbNamedVar, ButtonNewVar, ButtonEditVar, ButtonDelVar, ButtonInsVar,
              ButtonFirst, ButtonPrevious, ButtonNext, ButtonLast, ButtonRemove, ButtonHelpV,
              ButtonRefreshV, ButtonImpExport, SetButtonsNavAll, SetButtonsEditAll
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  try { wPalV  = new Window("palette", undefined, undefined); }
  catch (e) {
    alert (KLD_V.BuildMsg (KLD_V.UItxt.wPalV.@msg_01, e.message));
    return;
  }
  wPalV.text    = KLD_V.UItxt.wPalV.@title.toString() + KLD_V.APP_VERSION;
  wPalV.margins = [5, 5, 5, 5]; // left, top, right, bottom
	wPalV.g1 = wPalV.add('group',undefined);
//wPalV.g1.spacing = 5;

	wPalV.g1.pVars = wPalV.g1.add('panel',undefined,KLD_V.UItxt.wPalV.@g1pVars.toString());

	wPalV.g1.pVars.Group1 = wPalV.g1.pVars.add('group',undefined);
	wPalV.g1.pVars.Group1.rbSystem = wPalV.g1.pVars.Group1.add('radiobutton',undefined,KLD_V.UItxt.wPalV.@g1pVarsGroup1rbSystem.toString());
	wPalV.g1.pVars.Group1.rbUser = wPalV.g1.pVars.Group1.add('radiobutton',undefined, KLD_V.UItxt.wPalV.@g1pVarsGroup1rbUser.toString());

	wPalV.g1.pVars.listVarNames = wPalV.g1.pVars.add('listbox',undefined,undefined);
	wPalV.g1.pVars.listVarNames.preferredSize.width = 160;
	wPalV.g1.pVars.listVarNames.preferredSize.height = 310;

	wPalV.g1.pCurVar = wPalV.g1.add('panel',undefined,KLD_V.UItxt.wPalV.@g1pCurVar.toString());
	wPalV.g1.pCurVar.alignment = [' ','top'];

	wPalV.g1.pCurVar.g3 = wPalV.g1.pCurVar.add('group',undefined);
  wPalV.g1.pCurVar.g3.alignment = ['fill',' '];

	wPalV.g1.pCurVar.g3.t1 = wPalV.g1.pCurVar.g3.add('statictext',undefined,KLD_V.UItxt.wPalV.@g1pCurVarg3t1.toString());
	wPalV.g1.pCurVar.g3.sVarName = wPalV.g1.pCurVar.g3.add('edittext',undefined,KLD_V.UItxt.wPalV.@g1pCurVarg3sVarName.toString());
	wPalV.g1.pCurVar.g3.sVarName.alignment = ['right',' '];
	wPalV.g1.pCurVar.g3.sVarName.preferredSize.width = 420;

  wPalV.g1.pCurVar.g4 = wPalV.g1.pCurVar.add('group',undefined);
  wPalV.g1.pCurVar.g4.alignment = ['fill',' '];

	wPalV.g1.pCurVar.g4.t2 = wPalV.g1.pCurVar.g4.add('statictext',undefined,KLD_V.UItxt.wPalV.@g1pCurVarg4t2.toString());
	wPalV.g1.pCurVar.g4.sVarValue = wPalV.g1.pCurVar.g4.add('edittext',undefined,KLD_V.UItxt.wPalV.@g1pCurVarg4sVarValue.toString(), {multiline: true});
	wPalV.g1.pCurVar.g4.sVarValue.alignment = ['right',' '];
	wPalV.g1.pCurVar.g4.sVarValue.preferredSize = {width: 420, height: 40};

	wPalV.g1.pCurVar.g5 = wPalV.g1.pCurVar.add('group',undefined);
	wPalV.g1.pCurVar.g5.alignment = ['fill',' '];

	wPalV.g1.pCurVar.g5.pBlk = wPalV.g1.pCurVar.g5.add('panel',undefined,KLD_V.UItxt.wPalV.@g1pCurVarg5pBlk.toString());

	wPalV.g1.pCurVar.g5.pBlk.listBBlocks = wPalV.g1.pCurVar.g5.pBlk.add('listbox',undefined,undefined);
	wPalV.g1.pCurVar.g5.pBlk.listBBlocks.preferredSize.width = 220;
	wPalV.g1.pCurVar.g5.pBlk.listBBlocks.preferredSize.height = 195;

	wPalV.g1.pCurVar.g5.pChrFmt = wPalV.g1.pCurVar.g5.add('panel',undefined,KLD_V.UItxt.wPalV.@g1pCurVarg5pChrFmt.toString());

	wPalV.g1.pCurVar.g5.pChrFmt.listCharFmts = wPalV.g1.pCurVar.g5.pChrFmt.add('listbox',undefined,undefined);
	wPalV.g1.pCurVar.g5.pChrFmt.listCharFmts.preferredSize.width = 180;
	wPalV.g1.pCurVar.g5.pChrFmt.listCharFmts.preferredSize.height = 195;
//                                                //--- Actions on variables buttons --------------
	wPalV.g1.pCurVar.gVarActions = wPalV.g1.pCurVar.add('group',undefined);

	wPalV.g1.pCurVar.gVarActions.btnNew = wPalV.g1.pCurVar.gVarActions.add('button',undefined,KLD_V.UItxt.wPalV.@g1pCurVargVarActionsbtnNew.toString());
	wPalV.g1.pCurVar.gVarActions.btnNew.helpTip = KLD_V.UItxt.wPalV.@g1pCurVargVarActionsbtnNewhelpTip.toString();

	wPalV.g1.pCurVar.gVarActions.btnEdit = wPalV.g1.pCurVar.gVarActions.add('button',undefined,KLD_V.UItxt.wPalV.@g1pCurVargVarActionsbtnEdit.toString());
	wPalV.g1.pCurVar.gVarActions.btnEdit.helpTip = KLD_V.UItxt.wPalV.@g1pCurVargVarActionsbtnEdithelpTip.toString();

	wPalV.g1.pCurVar.gVarActions.btnDelete = wPalV.g1.pCurVar.gVarActions.add('button',undefined,KLD_V.UItxt.wPalV.@g1pCurVargVarActionsbtnDelete.toString());
	wPalV.g1.pCurVar.gVarActions.btnDelete.helpTip = KLD_V.UItxt.wPalV.@g1pCurVargVarActionsbtnDeletehelpTip.toString();

	wPalV.g1.pCurVar.gVarActions.spacer = wPalV.g1.pCurVar.gVarActions.add('statictext',undefined,""); // to adjust btnInsert to the right
	wPalV.g1.pCurVar.gVarActions.spacer.preferredSize.width = 120;

	wPalV.g1.pCurVar.gVarActions.btnInsert = wPalV.g1.pCurVar.gVarActions.add('button',undefined,KLD_V.UItxt.wPalV.@g1pCurVargVarActionsbtnInsert.toString());
	wPalV.g1.pCurVar.gVarActions.btnInsert.helpTip = KLD_V.UItxt.wPalV.@g1pCurVargVarActionsbtnInserthelpTip.toString();
//                                                //--- Navigation buttons ------------------------
	wPalV.pNav = wPalV.add('panel',undefined,KLD_V.UItxt.wPalV.@pNav.toString());
  wPalV.pNav.alignment = ['fill',' '];
	wPalV.pNav.gNavi = wPalV.pNav.add('group',undefined);
	wPalV.pNav.gNavi.rbAny = wPalV.pNav.gNavi.add('radiobutton',undefined,KLD_V.UItxt.wPalV.@pNavgNavirbAny.toString());
  wPalV.pNav.gNavi.rbAny.helpTip = KLD_V.UItxt.wPalV.@pNavgNavirbAnyhelpTip.toString();
	wPalV.pNav.gNavi.rbNamed = wPalV.pNav.gNavi.add('radiobutton',undefined,KLD_V.UItxt.wPalV.@pNavgNavirbNamed.toString());
  wPalV.pNav.gNavi.rbNamed.helpTip = KLD_V.UItxt.wPalV.@pNavgNavirbNamedhelpTip.toString();

	wPalV.pNav.gNavi.btnFirst = wPalV.pNav.gNavi.add('button',undefined,"");
  wPalV.pNav.gNavi.btnFirst.graphics.font = ScriptUI.newFont ("Segoe UI Symbol", "", 12);
  wPalV.pNav.gNavi.btnFirst.helpTip = KLD_V.UItxt.wPalV.@pNavgNavibtnFirsthelpTip.toString();

	wPalV.pNav.gNavi.btnPrevious = wPalV.pNav.gNavi.add('button',undefined,"◀");
  wPalV.pNav.gNavi.btnPrevious.graphics.font = ScriptUI.newFont ("Segoe UI Symbol", "", 12);
  wPalV.pNav.gNavi.btnPrevious.helpTip = KLD_V.UItxt.wPalV.@pNavgNavibtnPrevioushelpTip.toString();

	wPalV.pNav.gNavi.btnNext = wPalV.pNav.gNavi.add('button',undefined,"▶");
  wPalV.pNav.gNavi.btnNext.graphics.font = ScriptUI.newFont ("Segoe UI Symbol", "", 12);
  wPalV.pNav.gNavi.btnNext.helpTip = KLD_V.UItxt.wPalV.@pNavgNavibtnNexthelpTip.toString();

	wPalV.pNav.gNavi.btnLast = wPalV.pNav.gNavi.add('button',undefined,"");
  wPalV.pNav.gNavi.btnLast.graphics.font = ScriptUI.newFont ("Segoe UI Symbol", "", 12);
  wPalV.pNav.gNavi.btnLast.helpTip = KLD_V.UItxt.wPalV.@pNavgNavibtnLasthelpTip.toString();

	wPalV.pNav.gNavi.spacer = wPalV.pNav.gNavi.add('statictext',undefined,""); // empty string, just length definition
//wPalV.pNav.gNavi.spacer.preferredSize.width = 45;
  wPalV.pNav.gNavi.spacer.preferredSize.width = 85;
	wPalV.pNav.gNavi.btnRemove = wPalV.pNav.gNavi.add('button',undefined,KLD_V.UItxt.wPalV.@pNavgNavibtnRemove.toString());
  wPalV.pNav.gNavi.btnRemove.helpTip = KLD_V.UItxt.wPalV.@pNavgNavibtnRemovehelpTip.toString();
//                                                //--- Button row Help, Refresh, Close -----------
	wPalV.gCtrl = wPalV.add('group',undefined);

	wPalV.gCtrl.btnHelp = wPalV.gCtrl.add('button',undefined,KLD_V.UItxt.wPalV.@gCtrlbtnHelp.toString());
  wPalV.gCtrl.btnHelp.helpTip = KLD_V.UItxt.wPalV.@gCtrlbtnHelphelpTip.toString();

	wPalV.gCtrl.btnRefresh = wPalV.gCtrl.add('button',undefined,KLD_V.UItxt.wPalV.@gCtrlbtnRefresh.toString());
  wPalV.gCtrl.btnRefresh.helpTip = KLD_V.UItxt.wPalV.@gCtrlbtnRefreshhelpTip.toString();

	wPalV.gCtrl.message = wPalV.gCtrl.add('statictext',undefined,"",{multiline: true}); // May get error message
	wPalV.gCtrl.message.preferredSize = [315, 30];  // -1 for automatic calcualtion not working here
	wPalV.gCtrl.message.graphics.foregroundColor = wPalV.gCtrl.message.graphics.newPen (wPalV.gCtrl.message.graphics.PenType.SOLID_COLOR, [1, 0, 0], 1);
	wPalV.gCtrl.message.justify = "left";


	wPalV.gCtrl.btnImpExport = wPalV.gCtrl.add('button',undefined,KLD_V.UItxt.wPalV.@gCtrlbtnImpExport.toString());
	wPalV.gCtrl.btnImpExport.preferredSize.width = 110;
  wPalV.gCtrl.btnImpExport.helpTip = KLD_V.UItxt.wPalV.@gCtrlbtnImpExporthelpTip.toString();

	wPalV.gCtrl.btnClose = wPalV.gCtrl.add('button',undefined,KLD_V.UItxt.wPalV.@gCtrlbtnClose.toString());
  wPalV.gCtrl.btnClose.helpTip = KLD_V.UItxt.wPalV.@gCtrlbtnClosehelpTip.toString();

// --- behaviour of edit fields -------------------------------------------------------------------
    wPalV.g1.pCurVar.g3.sVarName.onChange = function () {
      KLD_V.sVarName = wPalV.g1.pCurVar.g3.sVarName.text;
   };
    wPalV.g1.pCurVar.g4.sVarValue.onChange = function () {
      KLD_V.sVarValue = wPalV.g1.pCurVar.g4.sVarValue.text;
   };

// --- Update global arrays -----------------------------------------------------------------------
  KLD_V.RefreshGlobals ();                              // fill variable list

// --- behaviour of the lists ---------------------------------------------------------------------
// IMHO doubleClick is more user friendly as it indicates an action.
  wPalV.g1.pVars.listVarNames.onChange = function () { // --- single/double click into system/user variables
    var listIndex, sVarName, sValue;
    if (wPalV.g1.pVars.listVarNames.selection == null) {return;} // clicked into empty area
    listIndex = wPalV.g1.pVars.listVarNames.selection.valueOf();
    sVarName  = wPalV.g1.pVars.listVarNames.selection.text;
    wPalV.g1.pCurVar.g3.sVarName.text = sVarName;
    oVar      = KLD_V.oCurrentDoc.GetNamedVarFmt(sVarName);
    sValue    = oVar.Fmt
    wPalV.g1.pCurVar.g4.sVarValue.text = sValue;
    wPalV.g1.pCurVar.g4.sVarValue.active = true; // selected, ready for edting
    KLD_V.sVarName     = sVarName;
    KLD_V.sVarValue = sValue;
    KLD_V.SetButtonInsert (true);
    if (!KLD_V.bIsUserVar) {                      // Rebuild the building blocks
      KLD_V.CheckSystemBB (sVarName);
      KLD_V.FillDlgList (wPalV.g1.pCurVar.g5.pBlk.listBBlocks, KLD_V.asSysBlocks);
    }
    wPalV.gCtrl.message.text = " ";               // clear message
  };

  wPalV.g1.pCurVar.g5.pBlk.listBBlocks.onDoubleClick = function () { // --- Building blocks
    var listIndex, tmpText;
    listIndex = wPalV.g1.pCurVar.g5.pBlk.listBBlocks.selection.valueOf()
    tmpText   = wPalV.g1.pCurVar.g5.pBlk.listBBlocks.selection.text;
    wPalV.g1.pCurVar.g4.sVarValue.textselection = tmpText;
    KLD_V.sVarValue = wPalV.g1.pCurVar.g4.sVarValue.text;
  };

  wPalV.g1.pCurVar.g5.pChrFmt.listCharFmts.onDoubleClick = function () { // --- Character formats
    var listIndex, tmpText;
    if (wPalV.g1.pCurVar.g5.pChrFmt.listCharFmts.selection == null) {return;} // clicked into empty area
    listIndex = wPalV.g1.pCurVar.g5.pChrFmt.listCharFmts.selection.valueOf();
    tmpText   = wPalV.g1.pCurVar.g5.pChrFmt.listCharFmts.selection.text;
    wPalV.g1.pCurVar.g4.sVarValue.textselection = tmpText;
    KLD_V.sVarValue = wPalV.g1.pCurVar.g4.sVarValue.text;
  };
// --- behaviour of radio buttons -----------------------------------------------------------------
// to ease debuggin (see local vars in the functions) these are own functions outside the dialogue
  wPalV.g1.pVars.Group1.rbSystem.onClick          = function () {
    KLD_V.RbSystemVars ();
  };
  wPalV.g1.pVars.Group1.rbUser.onClick            = function () {
    KLD_V.RbUserVars ();
  };
  wPalV.pNav.gNavi.rbAny.onClick                  = function () {
    KLD_V.RbAnyVar ();
  };
  wPalV.pNav.gNavi.rbNamed.onClick                = function () {
    KLD_V.RbNamedVar ();
  };

// --- behaviour of the buttons -------------------------------------------------------------------
  wPalV.g1.pCurVar.gVarActions.btnNew.onClick     = function () {
    KLD_V.ButtonNewVar (KLD_V.sVarName, KLD_V.sVarValue);
  };
  wPalV.g1.pCurVar.gVarActions.btnEdit.onClick    = function () {
    if (wPalV.g1.pVars.listVarNames.selection == null) {return;} // no variable selected
    KLD_V.ButtonEditVar (wPalV.g1.pVars.listVarNames.selection.text, wPalV.g1.pCurVar.g3.sVarName.text, wPalV.g1.pCurVar.g4.sVarValue.text);
  };
  wPalV.g1.pCurVar.gVarActions.btnDelete.onClick  = function () {
    if (wPalV.g1.pVars.listVarNames.selection == null) {return;} // no variable selected
    KLD_V.ButtonDelVar ();
  };
  wPalV.g1.pCurVar.gVarActions.btnInsert.onClick  = function () {
    if (wPalV.g1.pVars.listVarNames.selection == null) {return;} // no variable selected
    KLD_V.ButtonInsVar ();
  };

  wPalV.pNav.gNavi.btnFirst.onClick               = function () {
    KLD_V.ButtonFirst ();
  };
  wPalV.pNav.gNavi.btnPrevious.onClick            = function () {
    KLD_V.ButtonPrevious ();
  };
  wPalV.pNav.gNavi.btnNext.onClick                = function () {
    KLD_V.ButtonNext ();
  };
  wPalV.pNav.gNavi.btnLast.onClick                = function () {
    KLD_V.ButtonLast ();
  };
  wPalV.pNav.gNavi.btnRemove.onClick              = function () {
    KLD_V.ButtonRemove ();
  };

  wPalV.gCtrl.btnHelp.onClick                     = function () {
    KLD_V.ButtonHelpV ();
  };
  wPalV.gCtrl.btnRefresh.onClick                  = function () {
    KLD_V.ButtonRefreshV ();
  };
  wPalV.gCtrl.btnImpExport.onClick                = function () {
    KLD_V.ButtonImpExport ();
  };
  wPalV.gCtrl.btnClose.onClick = function () {
    wPalV.close();
  };
// --- Final work in dialogue ---------------------------------------------------------------------
  if (KLD_V.nDocVars == 0) {                      // No variables at all are used in this document
    wPalV.gCtrl.message.text = KLD_V.UItxt.wPalV.@msg_02.toString();
    KLD_V.SetButtonsNavAll (false);
  };
  KLD_V.SetButtonsEditAll (true);                       // We are starting with User vars
  KLD_V.SetButtonInsert (false)
  wPalV.show();
} //=== end of PaletteVariables <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><


KLD_V.ButtonRefreshV = function () { // ===========================================================
/*            Refresh the global stuff and the list
Called by     UpdateDialogues (Notify), PaletteVariables
Calling       SetButtonsNavAll, CollectVarsInDoc, GetSystemVars, GetUserVars, RefreshGlobals, SetButtonsEditAll
*/
var oDoc = app.ActiveDoc;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  wPalV.gCtrl.message.text = " ";
  KLD_V.SetButtonsNavAll (true);
  KLD_V.oCurrentDoc = oDoc;
//KLD_V.SetDisplay (false);
  KLD_V.CollectVarsInDoc (oDoc, KLD_V.aoDocVars);
//KLD_V.SetDisplay (true);
  KLD_V.GetSystemVars (KLD_V.oCurrentDoc, KLD_V.asSysVarNames);
  KLD_V.GetUserVars (KLD_V.oCurrentDoc, KLD_V.asUsrVarNames);
  KLD_V.RefreshGlobals (true);
  if (KLD_V.nDocVars == 0) {                      // No variables at all are used in this document
    wPalV.gCtrl.message.text = KLD_V.UItxt.wPalV.@msg_02.toString();
    KLD_V.SetButtonsEditAll (false);
    KLD_V.SetButtonsNavAll (false);
  };
} //--- end ButtonRefreshV ------------------------------------------------------------------------

KLD_V.ButtonEditVar = function (sName, sVarName, sVarValue) { // ==================================
/*            Edit name/contents of variable
Arguments     sName:        current name in list
              sVarName:     new variable name
              sVarValue: new contents
Called by     PaletteVariables
Calling       StrTrim, BuildMsg, GetUserVars, FillDlgList, GetSystemVars, CollectVarsInDoc, SetButtonInsert
Comment       This changes the list of variables - nothing is selected after this operation
              For system vars only the conents can be changed - field name is inactive
*/
var oDoc = KLD_V.oCurrentDoc, oVar, sValue;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  oVar =    oDoc.GetNamedVarFmt (sName);
  sValue    = oVar.Fmt
  if (sName == sVarName && sValue == sVarValue) {return;} // nothing has changed
  if (sVarName == "" || KLD_V.StrTrim (sVarName) == "") {
    wPalV.gCtrl.message.text = KLD_V.BuildMsg (KLD_V.UItxt.ButtonEditVar.@msg_01, sVarName);
    return;
  }
  if (sName != sVarName) {                        // name has changed (only possibe for user var)
    oVar.Name = sVarName;
  }
  if (sValue != sVarValue) {                      // contents has changed
    oVar.Fmt = sVarValue;
  }
  if (KLD_V.bIsUserVar) {                         // user var changed
    KLD_V.GetUserVars (KLD_V.oCurrentDoc, KLD_V.asUsrVarNames);
    KLD_V.FillDlgList (wPalV.g1.pVars.listVarNames, KLD_V.asUsrVarNames);
  } else {                                        // system var changed
    KLD_V.GetSystemVars (KLD_V.oCurrentDoc, KLD_V.asSysVarNames);
    KLD_V.FillDlgList (wPalV.g1.pVars.listVarNames, KLD_V.asSysVarNames);
  }
  KLD_V.SetDisplay (false);
  KLD_V.CollectVarsInDoc (KLD_V.oCurrentDoc, KLD_V.aoDocVars); // Re-build the object array
  KLD_V.SetDisplay (true);
  KLD_V.SetButtonInsert (false);
} //--- end ButtonEditVar -------------------------------------------------------------------------

KLD_V.ButtonNewVar = function (sVarName, sVarValue) { // ==========================================
/*            Create new user variable
Called by     PaletteVariables
Calling       IsInArray, BuildMsg, StrTrim, FillDlgList, ClearEditArea, CollectVarsInDoc, SetButtonInsert
Comment       This changes the list of variables - nothing is selected after this operation
              Only user variables can be new (button inactive for system vars)
// >>>>>>>   should use DefineUserVariable
*/
var oDoc = KLD_V.oCurrentDoc, oVar;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  if (sVarName == undefined || sVarValue == undefined) {
    wPalV.gCtrl.message.text = KLD_V.UItxt.ButtonNewVar.@msg_01.toString();
    return;
  }
  if (wPalV.g1.pVars.listVarNames.selection != null) {
    if (sVarName == wPalV.g1.pVars.listVarNames.selection.text) {
      wPalV.g1.pCurVar.g3.sVarName.text = "";      // clear to force user
      wPalV.g1.pCurVar.g4.sVarValue.text = "";
      return;
    }
  }
  if ((KLD_V.IsInArray (KLD_V.asUsrVarNames, sVarName) != null) || (KLD_V.IsInArray (KLD_V.asSysVarNames, sVarName) != null)) {
    alert (KLD_V.BuildMsg (KLD_V.UItxt.ButtonNewVar.@msg_02, sVarName));
    return;
  }
  if (sVarName == "" || KLD_V.StrTrim (sVarName) == "") {
    alert (KLD_V.BuildMsg (KLD_V.UItxt.ButtonNewVar.@msg_03, sVarName));
    return;
  }
  oVar = oDoc.NewNamedVarFmt (sVarName);
  oVar.Fmt = sVarValue;
  KLD_V.asUsrVarNames.push(sVarName);             // add to list
  KLD_V.nUsrVars = KLD_V.asUsrVarNames.length;
  KLD_V.asUsrVarNames.sort();
  KLD_V.FillDlgList (wPalV.g1.pVars.listVarNames, KLD_V.asUsrVarNames);
  KLD_V.ClearEditArea ();
  KLD_V.SetDisplay (false);
  KLD_V.CollectVarsInDoc (KLD_V.oCurrentDoc, KLD_V.aoDocVars); // Re-build the object array
  KLD_V.SetDisplay (true);
  KLD_V.bIsUserVar = true;                        // probably redundant
  KLD_V.SetButtonInsert (false);
} //--- end ButtonNewVar --------------------------------------------------------------------------

KLD_V.ButtonDelVar = function () { // =============================================================
/*            Delete current user variable
Called by     PaletteVariables
Calling       IsVarUsed, BuildMsg, DeleteVarInArray, FillDlgList, ClearEditArea, CollectVarsInDoc, SetButtonInsert
Comment       This changes the list of variables - nothing is selected after this operation
*/
var isOK, oVar, sLocalName;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  sLocalName = KLD_V.sVarName
  oVar = KLD_V.oCurrentDoc.GetNamedVarFmt(sLocalName);
  if (KLD_V.IsVarUsed (KLD_V.oCurrentDoc, KLD_V.aoDocVars, sLocalName)) {
    isOK = Alert (KLD_V.BuildMsg (KLD_V.UItxt.ButtonDelVar.@msg_01, sLocalName), Constants.FF_ALERT_CANCEL_DEFAULT);
    if (isOK != 0) {return};
  }
  oVar.Delete();
  KLD_V.DeleteVarInArray (sLocalName, KLD_V.asUsrVarNames); // delete from name array
  KLD_V.nUsrVars = KLD_V.asUsrVarNames.length;
  KLD_V.FillDlgList (wPalV.g1.pVars.listVarNames, KLD_V.asUsrVarNames);
  KLD_V.ClearEditArea ();
  KLD_V.SetDisplay (false);
  KLD_V.CollectVarsInDoc (KLD_V.oCurrentDoc, KLD_V.aoDocVars); // Re-build the object array
  KLD_V.SetDisplay (true);
  KLD_V.bIsUserVar = true;                        // probably redundant
  KLD_V.SetButtonInsert (false);
} //--- end ButtonDelVar --------------------------------------------------------------------------

KLD_V.ButtonFirst = function () { // ==============================================================
/*            Go to first variable in document
Called by     PaletteVariables
Calling       GoToVariableAny, GoToVariableNamed
Comment       If a system variable is found, the display may change to any type of page.
*/
var iVar;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  wPalV.gCtrl.message.text = " ";
  if (KLD_V.bGoNamed) {
    KLD_V.GoToVariableNamed (null, false);              // first in the array
  } else {
    KLD_V.GoToVariableAny (null, false);                   // first in the array
  }
} //---  end ButtonFirst --------------------------------------------------------------------------

KLD_V.ButtonPrevious = function () { // ===========================================================
/*            Go to previous variable in document
Called by     PaletteVariables
Calling       GoToVariableAny, GoToVariableNamed
Attention     This is not correct for named navigation! <<<<<<<<<<<<<<<<<
*/
var iVar;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  iVar = KLD_V.indexDocVars;
  wPalV.gCtrl.message.text = " ";
  if (iVar == 0) {
    wPalV.gCtrl.message.text = KLD_V.UItxt.GoToVariable.@msg_02.toString();
    return;
  }
  if (KLD_V.bGoNamed) {
    KLD_V.GoToVariableNamed (iVar - 1, false);          // previous in the array
  } else {
    KLD_V.GoToVariableAny (iVar - 1, false);
  }
} //---  end ButtonPrevious -----------------------------------------------------------------------

KLD_V.ButtonNext = function () { // ===============================================================
/*            Go to next variable in document
Called by     PaletteVariables
Calling       GoToVariableAny, GoToVariableNamed
Attention     This is not correct for named navigation! <<<<<<<<<<<<<<<<<
*/
var iVar, jMax;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  iVar = KLD_V.indexDocVars;
  jMax = KLD_V.nDocVars - 1;
  wPalV.gCtrl.message.text = " ";
  if (iVar == jMax) {
    wPalV.gCtrl.message.text = KLD_V.UItxt.GoToVariable.@msg_02.toString();
    return;
  }
  if (KLD_V.bGoNamed) {
    KLD_V.GoToVariableNamed (iVar + 1, true);           // next in the array
  } else {
    KLD_V.GoToVariableAny (iVar + 1, true);
  }
} //---  end ButtonNext ---------------------------------------------------------------------------

KLD_V.ButtonLast = function () { // ===============================================================
/*            Go to last variable in document
Called by     PaletteVariables
Calling       GoToVariableAny, GoToVariableNamed
Attention     This is not correct for named navigation! <<<<<<<<<<<<<<<<<
*/
var iVar;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  iVar = KLD_V.nDocVars - 1;
  wPalV.gCtrl.message.text = " ";
  if (KLD_V.bGoNamed) {
    KLD_V.GoToVariableNamed (null, true);               // last in the array
  } else {
    KLD_V.GoToVariableAny (null, true);
  }
} //---  end ButtonLast ---------------------------------------------------------------------------

KLD_V.ButtonRemove = function () { // =============================================================
/*            Remove the variable from the text
Called by     PaletteVariables
Calling       RemoveTextRange
*/
var oDoc, oTR, iVar;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  oDoc = KLD_V.oCurrentDoc;
  iVar = KLD_V.indexDocVars;
  oTR  = KLD_V.aoDocVars[iVar].TextRange;
  KLD_V.RemoveTextRange (oDoc, oTR);                    // this removed the iVar item from aDocVars
  KLD_V.aoDocVars.splice (iVar, 1);                // remove from array
  KLD_V.nDocVars = KLD_V.aoDocVars.length;
  if (iVar > 0) {
    KLD_V.indexDocVars = iVar - 1;                // go to previous if possible.
  }
} //---  end ButtonRemove -------------------------------------------------------------------------

KLD_V.ButtonInsVar = function () { // =============================================================
/*            Insert variable at current location or replace selection
Called by     PaletteVariables
Calling       ClearEditArea, CollectVarsInDoc
Attention     Replacing the selection will remove any following blank if Smart Spaces is on.
*/
var bSpaces, oDoc = KLD_V.oCurrentDoc, oTextLoc, oTR, oPgf, oVar, sVarName, sContents;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  oTR = KLD_V.oCurrentDoc.TextSelection;
  oTextLoc = oTR.beg;                             // insert at begin of selection
  sVarName = wPalV.g1.pCurVar.g3.sVarName.text;
  sContents=  wPalV.g1.pCurVar.g4.sVarValue.text;
  iSpaces = oDoc.SmartSpaces;                     // get current value
  oDoc.SmartSpaces = 0;                           // switch it off
  if (oTR.end.offset != oTR.beg.offset) {         // selection, not just location
    oDoc.TextSelection = oTR;                     // get text range
    oDoc.Clear(0);                                // clear it
  }
  oVar = oDoc.NewAnchoredFormattedVar (sVarName, oTextLoc);
  oVar.Fmt = sContents;
  oDoc.SmartSpaces = iSpaces;                     // restore saved value
  KLD_V.ClearEditArea ();
  KLD_V.SetDisplay (false);
  KLD_V.CollectVarsInDoc (oDoc, KLD_V.aoDocVars);       // the global array must be renewed
  KLD_V.SetDisplay (true);
} //---  end ButtonInsVar -------------------------------------------------------------------------

KLD_V.ButtonHelpV = function () { // ==============================================================
/*
Called by     PaletteVariables
Calling       GetScriptPath, OpenPdfAtDestination,
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  KLD_V.sHelpFile = File (KLD_V.GetScriptPath () + "\\" + KLD_V.APP_NAME + ".pdf"); // abs URI notation
  if (KLD_V.sHelpFile.exists) {
    KLD_V.OpenPdfAtDestination (KLD_V.sHelpFile, "nameddest=M8.newlink.FMvars1");
  }
//KLD_V.OpenHelpFile ();
} //---  end ButtonHelpV --------------------------------------------------------------------------

KLD_V.ButtonImpExport = function () { // ==========================================================
/*            Import or exprt to FM file
Called by     PaletteVariables
Calling       DialogueTransfer
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  KLD_V.DialogueTransfer ();
} //---  end ButtonImpExport ----------------------------------------------------------------------

KLD_V.SyncEditArea = function (bSystemVar) { // ===================================================
/*            Synchronise the editing area with the found variable
Arguments     bSystemVar: true if found variable is system variable
Returns       Updates editing area
Called by     GoToVariable, GoToVariableAny
Calling       RbSystemVars, RbUserVars,
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  if (bSystemVar) {
    KLD_V.RbSystemVars ()
  } else {
    KLD_V.RbUserVars ();
  }
} //---  end SyncEditArea -------------------------------------------------------------------------

KLD_V.RbSystemVars = function () { // =============================================================
/*            Switch to system variables
Called by     PaletteVariables, SyncEditArea
Calling       GetSystemVars, FillDlgList,
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  KLD_V.bIsUserVar = false;
  KLD_V.GetSystemVars (KLD_V.oCurrentDoc, KLD_V.asSysVarNames);
  wPalV.g1.pVars.Group1.rbSystem.value = true;
  wPalV.g1.pCurVar.g3.sVarName.enabled            = false;   // can not be edited
  KLD_V.FillDlgList (wPalV.g1.pVars.listVarNames, KLD_V.asSysVarNames);
  KLD_V.FillDlgList (wPalV.g1.pCurVar.g5.pBlk.listBBlocks, KLD_V.asSysBlocksAll);
  wPalV.g1.pCurVar.g5.pBlk.listBBlocks.enabled    = true;
  wPalV.g1.pCurVar.gVarActions.btnNew.enabled     = false;   // function not allowed
  wPalV.g1.pCurVar.gVarActions.btnEdit.enabled    = true;    // function allowed partially
  wPalV.g1.pCurVar.gVarActions.btnDelete.enabled  = false;   // function not allowed
} //---  end RbSystemVars -------------------------------------------------------------------------

KLD_V.RbUserVars = function () { // ===============================================================
/*            Switch to user variables
Called by     PaletteVariables, SyncEditArea
Calling       GetUserVars, FillDlgList,
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  KLD_V.bIsUserVar = true;
  KLD_V.GetUserVars (KLD_V.oCurrentDoc, KLD_V.asUsrVarNames);
  wPalV.g1.pVars.Group1.rbUser.value = true;
  wPalV.g1.pCurVar.g3.sVarName.enabled            = true;
  KLD_V.FillDlgList (wPalV.g1.pVars.listVarNames, KLD_V.asUsrVarNames);
  wPalV.g1.pCurVar.g5.pBlk.listBBlocks.enabled    = false;
  wPalV.g1.pCurVar.gVarActions.btnNew.enabled     = true;
  wPalV.g1.pCurVar.gVarActions.btnEdit.enabled    = true;
  wPalV.g1.pCurVar.gVarActions.btnDelete.enabled  = true;
} //---  end RbUserVars ---------------------------------------------------------------------------

KLD_V.RbAnyVar = function () { // =================================================================
/*            Walk through any variables
Called by     PaletteVariables
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  KLD_V.bGoNamed = false;
  wPalV.gCtrl.message.text = " ";
} //---  end RbAnyVar -----------------------------------------------------------------------------

KLD_V.RbNamedVar = function () { // ===============================================================
/*            Walk through variables names as selected
Called by     PaletteVariables
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  KLD_V.bGoNamed = true;
  wPalV.gCtrl.message.text = " ";
} //---  end RbNamedVar ---------------------------------------------------------------------------

KLD_V.ClearEditArea = function () { // ============================================================
/*            clear variable name and contents fields
Called by     ButtonNewVar, ButtonDelVar, ButtonInsVar
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  wPalV.g1.pCurVar.g3.sVarName.text = "";
  wPalV.g1.pCurVar.g4.sVarValue.text = ""
  KLD_V.sVarName = undefined;
  KLD_V.sVarValue = undefined;
} //---  end ClearEditArea ------------------------------------------------------------------------

KLD_V.RefreshGlobals = function (isFirst) { // ====================================================
/*            Fill global arrays and palette lists
              Fill the global arrays relevant for PaletteVariables.
Arguments     isFirst: true if called from Palette, false if called from Notify
Returns       ???
Called by     PaletteVariables, ButtonRefreshV
Calling       SaveCurrentLocation, FillDlgList, GetCharFmtsList, GetIndexNearestVariable, SetButtonsEditAll, RestoreLocation
*/
var oDoc = app.ActiveDoc, oLocation;
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  KLD_V.oCurrentDoc = oDoc;
  if (!oDoc.ObjectValid()) {
    return null;                                  // no document open
  }
  oLocation = KLD_V.SaveCurrentLocation (oDoc);         // Save current cusor / TR
  wPalV.g1.pVars.Group1.rbUser.value = true;      // start with users
  KLD_V.bIsUserVar = true;
  KLD_V.FillDlgList (wPalV.g1.pVars.listVarNames, KLD_V.asUsrVarNames)

  KLD_V.GetCharFmtsList (KLD_V.oCurrentDoc, KLD_V.asCharFmts);
  KLD_V.FillDlgList (wPalV.g1.pCurVar.g5.pChrFmt.listCharFmts, KLD_V.asCharFmts);

  wPalV.pNav.gNavi.rbAny.value = true;            // default
  KLD_V.bGoNamed = false;
  KLD_V.indexDocVars = KLD_V.GetIndexNearestVariable (KLD_V.aoDocVars);
  if (KLD_V.indexDocVars  === null) {KLD_V.indexDocVars = 0;} // no selection in doc
  KLD_V.SetButtonsEditAll (true)
  KLD_V.RestoreLocation (oDoc, oLocation);              // Restore  cursor location/TR
} //--- end RefreshGlobals ------------------------------------------------------------------------

KLD_V.SetButtonsEditAll = function (bWhat) { // ===================================================
/*            Set/reset all edit buttons
Called by     PaletteVariables, ButtonRefreshV, RefreshGlobals
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  wPalV.g1.pCurVar.gVarActions.btnNew.enabled     = true;   // allways OK
  wPalV.g1.pCurVar.gVarActions.btnEdit.enabled    = bWhat;
  wPalV.g1.pCurVar.gVarActions.btnDelete.enabled  = bWhat;
  wPalV.g1.pCurVar.gVarActions.btnInsert.enabled  = bWhat;
} //--- end SetButtonsEditAll ---------------------------------------------------------------------

KLD_V.SetButtonInsert = function (bWhat) { // =====================================================
/*            set/reset Insert
Called by     PaletteVariables, ButtonEditVar, ButtonNewVar, ButtonDelVar
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  wPalV.g1.pCurVar.gVarActions.btnInsert.enabled  = bWhat;
} //--- end SetButtonInsert -----------------------------------------------------------------------

KLD_V.SetButtonsNavAll = function (bWhat) { // ====================================================
/*            Set/reset all navigation buttons
Called by     PaletteVariables, ButtonRefreshV
*/
  if (KLD_V.settings.bIsDebug) {KLD_V.ZTrace ();}

  wPalV.pNav.gNavi.btnFirst.enabled              = bWhat;
  wPalV.pNav.gNavi.btnPrevious.enabled           = bWhat;
  wPalV.pNav.gNavi.btnNext.enabled               = bWhat;
  wPalV.pNav.gNavi.btnLast.enabled               = bWhat;
  wPalV.pNav.gNavi.btnRemove.enabled             = bWhat;
} //--- end ButtonsNavAllOff ----------------------------------------------------------------------